#open "palm";;

(* Minimal IO *)
let std_in = open_or_create_in 0;;
let std_out = open_out 1;;

let print_char =
  output_char std_out
;;
let print_string =
  output_string std_out
;;
let print_int i =
  print_string (int__string_of_int i)
;;
let print_endline s =
  print_string s;
  print_char `\n`
;;

let print_newline () =
  print_char `\n`
;;


let cleanup () =
  print_debug "close_in";
  close_in std_in;
  print_debug "close_out";
  close_out std_out
;;

at_exit	minio__cleanup;;
