#open "palm";;
#open "events";;

let get_features flag =
  let features = ref [] in
  let idx = ref 0 in
  try
    while true do
      features := ftr__get_by_index !idx flag :: !features;
      incr idx;
    done;
    !features
  with
    sys__Sys_error _ -> !features
;;

let pp_features = 
  map (fun (lid, num, val) -> lid ^ "." ^ string_of_int num^ "=" ^
       format_int "%02lx" (int_of_char val.[0]) ^
       format_int "%02lx" (int_of_char val.[1]) ^
       format_int "%02lx" (int_of_char val.[2]) ^
       format_int "%02lx" (int_of_char val.[3]))
;;

let main_handler e =
  let form = frm__get_active_form() in
  match e with
  | FrmOpenEvent id ->
      frm__draw_form form;
      true
  | CtlSelectEvent (101, _, true) -> (* select ram features *)
      let l = get_features false
      and lst = lst__get form 103 in
      lst__set_lst_choices lst (pp_features (rev l));
      lst__erase_list lst;
      lst__draw_list lst;
      true
  | CtlSelectEvent (102, _, true) -> (* select ram features *)
      let l = get_features true
      and lst = lst__get form 103 in
      lst__set_lst_choices lst (pp_features (rev l));
      lst__erase_list lst;
      lst__draw_list lst;
      true
  | MenuEvent 102 -> freemem__f (); true
  | MenuEvent 103 -> freemem__gc(); true
  | e -> false
;;


let mainForm = 1000;;
let main () =
  events__set_apphandler (function 
      FrmLoadEvent id -> 
	let form = frm__init_form id in
	if id = mainForm then begin
	  set_formhandler id main_handler
	end;
	frm__set_active_form form;
	true
    | FrmOpenEvent id ->
	frm__draw_form(frm__get_active_form());
	true
    | e -> (* do with other handlers *)
	false);
  frm__goto_form(mainForm)
;;

let _ = main ()
;;

  
