type dm;;

type ID == string
type creator == string  (* 4 chars *)
type dbtype == string   (* 4 chars *)
type restype == string

type dbinfo = {
    db_name : string;
    db_attributes : int;
    db_version : int;
    db_crDate : int;
    db_modDate : int;
    db_bckupDate : int;
    db_modNum : int;
    db_appInfoID : ID;
    db_sortInfoID : ID;
    db_type : dbtype;
    db_creator : creator;
  } 

value dmArchiveRecord : dm -> int -> unit
    = 2 "clpalm_dmArchiveRecord"
and   dmCloseDatabase : dm -> unit
    = 1 "clpalm_dmCloseDatabase"
and   dmCreateDatabase : int -> string -> creator -> dbtype -> unit
    = 4 "clpalm_dmCreateDatabase"
and   dmDatabaseInfo : int -> ID -> dbinfo
    = 2 "clpalm_dmDatabaseInfo"
and   dmDatabaseProtect : int -> ID -> bool -> unit
    = 3 "clpalm_dmDatabaseProtect"
and   dmDatabaseSize : int -> ID -> (int * int * int)
    = 2 "clpalm_dmDatabaseSize"
and   dmDeleteCategory : dm -> int -> unit
    = 2 "clpalm_dmDeleteCategory"
and   dmDeleteDatabase : int -> ID -> unit
    = 2 "clpalm_dmDeleteDatabase"
and   dmDeleteRecord : dm -> int -> unit
    = 2 "clpalm_dmDeleteRecord"
and   dmFindDatabase : int -> string -> ID
    = 2 "clpalm_dmFindDatabase"
and   dmFindRecordByID : dm -> ID -> int
    = 2 "clpalm_dmFindRecordByID"
and   dmFindResourceType : dm -> restype -> int -> int
    = 3 "clpalm_dmFindResourceType"
and   dmGetAppInfoID : dm -> ID
    = 1 "clpalm_dmGetAppInfoID"
and   dmGetDatabase : int -> int -> ID
    = 2 "clpalm_dmGetDatabase"
;;
