(* Input-output *)

#open "bool";;
#open "eq";;
#open "exc";;
#open "int";;
#open "fstring";;

type in_channel
 and out_channel
;;

let _ = palmio_init "Data" "Caml" "CamlDB" ;;

let input chan buff ofs len =
  if len < 0 || ofs < 0 || ofs+len > string_length buff then
    invalid_arg "input"
  else
    fast_input chan buff ofs len
;;

let output chan buff ofs len =
  if len < 0 || ofs < 0 || ofs+len > string_length buff then
    invalid_arg "output"
  else
    fast_output chan buff ofs len
;;

let output_string channel s =
  fast_output channel s 0 (string_length s)
;;


