#open "palm";;
#open "exc";;

let table = (hashtbl__new 1 : (lst , int) hashtbl__t);;

let set_lst_choices lst choices =
  (* if we already have one, remove it *)
  try 
    let n = hashtbl__find table lst in
    free_list n;
    hashtbl__remove table lst;
    raise Not_found
  with
    Not_found ->
      (* build the list and add it to the table *)
      let n = set_list lst choices in
      hashtbl__add table lst n;
      ()
;;

(* At exit time, erase all these resources *)
let _ = 
  at_exit (fun () -> hashtbl__do_table (fun lst n -> free_list n) table)
;;
