#open "ref";;

(* Cleanup is essential on PalmOS (e.g. record locking).
 * Thus we provide a trivial at_exit call and encourage
 * applications to use it.
 *)

let exit_function = ref (fun () -> ())
;;
let at_exit f =
  let g = !exit_function in
  exit_function := (fun () -> f(); g())
;;
(* do once only *)
let do_at_exit () = 
  let f = !exit_function in
  exit_function := (fun () -> ());
  f()
;;

