(* Common types *)

type rsrcId == int;;	  (* Word, so they fit in int *)
type lid == string;;	  (* ULong ids : use 4 byte string *)

(* The followings are Ptr types (eg. pointers) *)
type control;;
type field;;
type lst;;
type form;;
type menu;;
type scrollbar;;
type table;;
type win;;

type handle;;

type ticks == int;;
type dayselector;;

(* Commonly used types *)
type point = { x : int; y : int };;
type rect == point * point;;

type direction = Up | Down | Left | Right;; (* UI/Window.h/DirectionType *)

value at_exit : (unit -> unit) -> unit;;



(* Various PalmOS functions *)
value abt_show_about : lid -> unit = 1 "clpalm_AbtShowAbout";;

value sysKeyboardDialog : int -> unit = 1 "clpalm_sysKeyboardDialog";;
value sysGraffitiReferenceDialog : int -> unit = 1 "clpalm_sysGraffitiReferenceDialog"
;;




(* Info = 1, Warning = 2, Error = 3, Startup = 4, Alarm = 5, Confirmation = 6,
   Click = 7
   TODO: define type
 *)
value sndPlaySystemSound : int -> unit
    = 1 "clpalm_sndPlaySystemSound"
;;

value mem_heap_free_bytes : int -> int * int = 1 "clpalm_MemHeapFreeBytes";;

(*-*)
value print_debug : string -> unit = 1 "print_debug";;
value ser_debug : string -> unit = 1 "con_debug";;
value do_at_exit : unit -> unit;;
