(* System interface. *)

(* This module provides a simple interface to the operating system. *)

exception Sys_error of string;;
        (* Raised by some functions in the [sys] and [io] modules,
           when the underlying system calls fail. The argument to
           [Sys_error] is a string describing the error. The texts
           of the error messages are implementation-dependent, and should
           not be relied upon to catch specific system errors. *)

exception Break;;
        (* Exception [Break] is raised on user interrupt if [catch_break]
           is on. *)

(*--*)

value max_vect_length : int
  and max_string_length : int
        (* Max length for arrays and strings, as imposed by the
           runtime system. *)
;;
value word_size : int
        (* Size of a machine word (in bits). *)
;;
