#include "mlvalues.h"
#include "fail.h"
#include "alloc.h"
#include "memory.h"

/* Font functions */
value clpalm_FntAverageCharWidth(value rien) /* ML */
{
  return Val_int(FntAverageCharWidth());
}

value clpalm_FntBaseLine(value rien) /* ML */
{
  return Val_int(FntBaseLine());
}

value clpalm_FntCharHeight(value rien) /* ML */
{
  return Val_int(FntCharHeight());
}

value clpalm_FntCharsInWidth(value str, value pars) /* ML */
{
  Int stringWidth = Int_val(Field(pars, 0));
  Int stringLength = Int_val(Field(pars, 1));
  Boolean fitWithinWidth = Bool_val(Field(pars, 2));
  value res;

  FntCharsInWidth(String_val(str), &stringWidth, &stringLength, &fitWithinWidth);
  res = alloc_tuple(3);
  Field(res, 0) = Val_int(stringWidth);
  Field(res, 1) = Val_int(stringLength);
  Field(res, 2) = Val_bool(fitWithinWidth);
  return res;
}

value clpalm_FntCharsWidth(value str, value len ) /* ML */
{
  return Val_int(FntCharsWidth(String_val(str), Int_val(len)));
}

value clpalm_FntCharWidth(value ch) /* ML */
{
  return Val_int(FntCharWidth((char)Int_val(ch)));
}

value clpalm_FntDescenderHeight(value rien) /* ML */
{
  return Val_int(FntDescenderHeight());
}

value clpalm_FntGetFont(value rien) /* ML */
{
  return Atom(FntGetFont());
}

value clpalm_FntGetScrollValues(value str, value wrap, value spos) /* ML */
{
  Word lines, topLine;
  value res;
  FntGetScrollValues(String_val(str), Int_val(wrap), Int_val(spos),
		     &lines, &topLine);
  res = alloc_tuple(2);
  Field(res, 0) = Val_int(lines);
  Field(res, 1) = Val_int(topLine);
  return res;
}

value clpalm_FntLineHeight(value rien) /* ML */
{
  return Val_int(FntLineHeight());
}

value clpalm_FntLineWidth(value str, value len) /* ML */
{
  return Val_int(FntLineWidth(String_val(str), Int_val(len)));
}

/* This one is in the docs, but not in the includes !
value clpalm_FntProportionalFont(value rien)
{
  return Val_bool(FntProportionalFont());
}
*/

value clpalm_FntSetFont(value id) /* ML */
{
  return Atom(FntSetFont(Tag_val(id)));
}

value clpalm_FntWordWrap(value str, value maxw) /* ML */
{
  return Val_int(FntWordWrap(String_val(str), Int_val(maxw)));
}

value clpalm_FntWordWrapReverseNLines(value str, value maxw) /* ML */
{
  Word linesToScroll, scrollPos;
  value res;
  FntWordWrapReverseNLines(String_val(str), Int_val(maxw),
			   &linesToScroll, &scrollPos);
  res = alloc_tuple(2);
  Field(res, 0) = Val_int(linesToScroll);
  Field(res, 1) = Val_int(scrollPos);
  return res;
}
