#include "mlvalues.h"
#include "fail.h"
#include "alloc.h"
#include "memory.h"
#include "str.h"
#include "sys.h"
#include "clPalm_cvt.h"


value clpalm_FtrGet(value vcreator, value num) /* ML */
{
  DWord creator = id_of_string(vcreator);
  DWord val;
  FtrGet(creator, Int_val(num), &val);
  return id_of_string(val);
}

value clpalm_FtrGetByIndex(value vindex, value rom) /* ML */
{
  Err err;
  DWord creator;
  UInt num;
  DWord val;

  err = FtrGetByIndex(Int_val(vindex), Bool_val(rom),
		      &creator, &num, &val);
  if (err) sys_error(err);
  {
    value res;
    Push_roots(r, 2);
    r[0] = string_of_id(creator);
    r[1] = string_of_id(val);
    res = alloc_tuple(3);
    Field(res, 0) = r[0];
    Field(res, 1) = Val_int(num);
    Field(res, 2) = r[1];
    Pop_roots();
    return res;
  }
}

value clpalm_FtrSet(value vcreator, value num, value val) /* ML */
{
  Err err = FtrSet(id_of_string(vcreator), Int_val(num), id_of_string(val));
  if (err == 0) sys_error(err);
  return Val_unit;
}

value clpalm_FtrUnregister(value vcreator, value num) /* ML */
{
  Err err = FtrUnregister(id_of_string(vcreator), Int_val(num));
  if (err == 0) sys_error(err);
  return Val_unit;
}
