#include "mlvalues.h"
#include "fail.h"
#include "alloc.h"
#include "clPalm_cvt.h"

value clpalm_TblDrawTable(value tbl) /* ML */
{
  TblDrawTable((TablePtr)tbl);
  return Val_unit;
}

value clpalm_TblEditing(value tbl) /* ML */
{
  return Val_bool(TblEditing((TablePtr)tbl));
}

value clpalm_TblEraseTable(value tbl) /* ML */
{
  TblEraseTable((TablePtr)tbl);
  return Val_unit;
}

value clpalm_TblFindRowID(value tbl, value id) /* ML */
{
  Word row;
  Boolean found = TblFindRowID((TablePtr)tbl, Int_val(id), &row);
  if (found) return Val_int(row);
  else mlraise(NOT_FOUND_EXN);
}

value clpalm_TblGetBounds(value tbl) /* ML */
{
  RectangleType rect;
  TblGetBounds((TablePtr)tbl, &rect);
  return rect_c2ml(&rect);
}

value clpalm_TblGetColumnSpacing(value tbl, value col) /* ML */
{
  return Val_int(TblGetColumnSpacing((TablePtr)tbl, Int_val(col)));
}

value clpalm_TblGetColumnWidth(value tbl, value col) /* ML */
{
  return Val_int(TblGetColumnWidth((TablePtr)tbl, Int_val(col)));
}

value clpalm_TblGetCurrentField(value tbl) /* ML */
{
  FieldPtr f = TblGetCurrentField((TablePtr)tbl);
  return null_ptr((value) f);
}

value clpalm_TblGetItemBounds(value tbl, value row, value col) /* ML */
{
  RectangleType rect;
  TblGetItemBounds((TablePtr)tbl, Int_val(row), Int_val(col), &rect);
  return rect_c2ml(&rect);
}

value clpalm_TblGetItemInt(value tbl, value row, value col) /* ML */
{
  return Val_int(TblGetItemInt((TablePtr)tbl, Int_val(row), Int_val(col)));
}

value clpalm_TblGetLastUsableRow(value tbl) /* ML */
{
  return Val_int(TblGetLastUsableRow((TablePtr)tbl));
}

value clpalm_TblGetNumberOfRows(value tbl) /* ML */
{
  return Val_int(TblGetNumberOfRows((TablePtr)tbl));
}

value clpalm_TblGetRowHeight(value tbl, value row) /* ML */
{
  return Val_int(TblGetRowHeight((TablePtr)tbl, Int_val(row)));
}

value clpalm_TblGetRowID(value tbl, value row) /* ML */
{
  return Val_int(TblGetRowID((TablePtr)tbl, Int_val(row)));
}

value clpalm_TblGetSelection(value tbl) /* ML */
{
  Word row, col;
  Boolean high = TblGetSelection((TablePtr)tbl, &row, &col);
  value res = alloc_tuple(3);
  Field(res, 0) = Val_int(row);
  Field(res, 1) = Val_int(col);
  Field(res, 3) = Val_bool(high);
  return res;
}

value clpalm_TblGrabFocus(value tbl, value row, value col) /* ML */
{
  TblGrabFocus((TablePtr)tbl, Int_val(row), Int_val(col));
  return Val_unit;
}

value clpalm_TblHandleEvent(value tbl, value ev) /* ML */
{
  EventType e;
  clpalm_mlevent2c(ev, &e);
  return Val_bool(TblHandleEvent((TablePtr)tbl,&e));
}

value clpalm_TblHasScrollBar(value tbl, value flag) /* ML */
{
  TblHasScrollBar((TablePtr)tbl, Bool_val(flag));
  return Val_unit;
}

value clpalm_TblInsertRow(value tbl, value row) /* ML */
{
  TblInsertRow((TablePtr)tbl, Int_val(row));
  return Val_unit;
}

value clpalm_TblMarkRowInvalid(value tbl, value row) /* ML */
{
  TblMarkRowInvalid((TablePtr)tbl, Int_val(row));
  return Val_unit;
}

value clpalm_TblMarkTableInvalid(value tbl) /* ML */
{
  TblMarkTableInvalid((TablePtr)tbl);
  return Val_unit;
}

value clpalm_TblRedrawTable(value tbl) /* ML */
{
  TblRedrawTable((TablePtr)tbl);
  return Val_unit;
}

value clpalm_TblReleaseFocus(value tbl) /* ML */
{
  TblReleaseFocus((TablePtr)tbl);
  return Val_unit;
}

value clpalm_TblRemoveRow(value tbl, value row) /* ML */
{
  TblRemoveRow((TablePtr)tbl, Int_val(row));
  return Val_unit;
}

value clpalm_TblRowInvalid(value tbl, value row) /* ML */
{
  return Val_bool(TblRowInvalid((TablePtr)tbl, Int_val(row)));
}

value clpalm_TblRowSelectable(value tbl, value row) /* ML */
{
  return Val_bool(TblRowSelectable((TablePtr)tbl, Int_val(row)));
}

value clpalm_TblRowUsable(value tbl, value row) /* ML */
{
  return Val_bool(TblRowUsable((TablePtr)tbl, Int_val(row)));
}

value clpalm_TblSelectItem(value tbl, value row, value col) /* ML */
{
  TblSelectItem((TablePtr)tbl, Int_val(row), Int_val(col));
  return Val_unit;
}

value clpalm_TblSetBounds(value tbl, value vrect) /* ML */
{
  RectangleType crect;
  rect_ml2c(vrect, &crect);
  TblSetBounds((TablePtr)tbl, &crect);
  return Val_unit;
}

value clpalm_TblSetColumnEditIndicator(value tbl, value col, value flag) /* ML */
{
  TblSetColumnEditIndicator((TablePtr)tbl, Int_val(col), Bool_val(flag));
  return Val_unit;
}

value clpalm_TblSetColumnSpacing(value tbl, value col, value spacing) /* ML */
{
  TblSetColumnSpacing((TablePtr)tbl, Int_val(col), Int_val(spacing));
  return Val_unit;
}

value clpalm_TblSetColumnUsabe(value tbl, value col, value flag) /* ML */
{
  TblSetColumnUsable((TablePtr)tbl, Int_val(col), Bool_val(flag));
  return Val_unit;
}

value clpalm_TblSetColumnWidth(value tbl, value col, value width) /* ML */
{
  TblSetColumnWidth((TablePtr)tbl, Int_val(col), Int_val(width));
  return Val_unit;
}

value clpalm_TblSetItemInt(value tbl, value row, value col, value v) /* ML */
{
  TblSetItemInt((TablePtr)tbl, Int_val(row), Int_val(col), Int_val(v));
  return Val_unit;
}
