#include "mlvalues.h"
#include "fail.h"
#include "alloc.h"
#include "str.h"
#include "clPalm_cvt.h"

/* Misc */
value clpalm_AbtShowAbout(value s) /* ML */
{
  AbtShowAbout(id_of_string(s));
  return Val_unit;
}

/* see Keyboard.h for possible values of argument */
value clpalm_sysKeyboardDialog(value kbdtype) /* ML */
{
  SysKeyboardDialog(Int_val(kbdtype));
  return Val_unit;
}

/* see GraffitiReference.h for possible values of argument */
value clpalm_sysGraffitiReferenceDialog(value kbdtype) /* ML */
{
  SysGraffitiReferenceDialog(Int_val(kbdtype));
  return Val_unit;
}

value clpalm_sndPlaySystemSound(value sndtype) /* ML */
{
  SndPlaySystemSound(Int_val (sndtype));
  return Val_unit;
}

/*
 * General catalog functions
 */

/* borrowed from memopad, with a twist */
/* this one can be used to return all catalog types */
value clpalm_GetObject(value form, value id) /* ML */
{
  return (value)FrmGetObjectPtr((FormPtr)form,
				FrmGetObjectIndex((FormPtr)form, Int_val(id)));
}

value clpalm_GetObjectIndex(value form, value id) /* ML */
{
  return Val_int(FrmGetObjectIndex((FormPtr)form, Int_val(id)));
}

value clpalm_GetFocusObject(value nothing) /* ML */
{
  FormPtr frm;
  Int focus;
        
  /* Get a pointer to the active form 
     and the index of the form object with focus. */
  frm = FrmGetActiveForm();
  focus = FrmGetFocus(frm);
        
  /* If no object has the focus, raise Not_found */
  if (focus == noFocus)
    mlraise(Atom(NOT_FOUND_EXN));
  else /* return a pointer to the object with focus. */
    return (value)FrmGetObjectPtr(frm, focus);
}


/*
 * Mem
 */
value clpalm_MemHeapFreeBytes (value heapn) /* ML */
{
  ULong free, max;
  value res;
  MemHeapCompact(Int_val(heapn));
  MemHeapFreeBytes(Int_val(heapn), &free, &max);
  res = alloc_tuple(2);
  Field(res, 0) = Val_int(free);
  Field(res, 1) = Val_int(max);
  return res;
}
