#include "mlvalues.h"
#include "fail.h"
#include "memory.h"
#include "alloc.h"
#include "str.h"
#include <UI/Rect.h>

/* Various conversions */

/* Utility: convert a 4 char string to an ULong */
ULong id_of_string(value str)
{
  if (string_length(str) != 4)
    raise_with_string(INVALID_EXN, "id_of_string");
  return *(ULong *)Bp_val(str);
}

/* and reverse */
value string_of_id(ULong id)
{
  value res = alloc_string(4);
  ((ULong *)(Bp_val(res)))[0] = id;
  return res;
}

value null_ptr(value ptr)
{
  if (ptr == NULL)
    mlraise(NOT_FOUND_EXN);
  else
    return ptr;
}

void rect_ml2c(value mlrect, RectanglePtr crect)
{
  crect->topLeft.x = Int_val(Field(Field(mlrect,0), 0));
  crect->topLeft.y = Int_val(Field(Field(mlrect,0), 1));
  crect->extent.x = Int_val(Field(Field(mlrect,1), 0));
  crect->extent.y = Int_val(Field(Field(mlrect,1), 1));
}

value rect_c2ml(RectanglePtr rect)
{
  value res;
  Push_roots(r,2);
  r[0] = alloc_tuple(2);
  Field(r[0],0) = Val_int(rect->topLeft.x);
  Field(r[0],1) = Val_int(rect->topLeft.y);
  r[1] = alloc_tuple(2);
  Field(r[1],0) = Val_int(rect->extent.x);
  Field(r[1],1) = Val_int(rect->extent.y);
  res = alloc_tuple(2);
  Field(res,0) = r[0];
  Field(res,1) = r[1];
  Pop_roots();
  return res;
}

