/* Primitives table:
 * there are several solutions to manage the primitive table.
 * a- have one table, created in the "application" layer, as it would be
 * one a traditional OS. In that case, when CamlLib/interp jumps to pointers
 * in this table, it refers to code in the application layer, and has only
 * to set a4 accordingly. Note, however, that most of this code will actually
 * be stubs that first set another a4 and then jump into some other layer.
 * Thus, we shoot for
 * b- have each layer define its own table, and dispatch accordingly.
 * 
 */
register void *reg_a4 asm("%a4");

extern c_primitive *primsa[];	/* the array of primitive arrays */
extern int numprims[];		/* indexes of frontiers */
extern void *globalp[];		/* the a4 for the layers */

extern void declare_prims(int layer, c_primitive *p, int len, void *layer_a4);

#define Setup_globals(n) \
  void *save_a4 = reg_a4;                                        \
  int layer = 0;                                                 \
  int primoffs = (n);                                            \
  c_primitive f;                                                 \
  while (primoffs >= numprims[layer]) {                          \
    primoffs -= numprims[layer]; layer++;                        \
  };                                                             \
  f = primsa[layer][primoffs];                                       \
  reg_a4 = globalp[layer];

#define Restore_globals reg_a4 = save_a4
