#ifndef _fail_
#define _fail_


#ifndef __palmos__
#include <setjmp.h>
#endif
#include "misc.h"
#include "mlvalues.h"

#define OUT_OF_MEMORY_EXN 0     /* "exc","Out_of_memory",1 */
#define SYS_ERROR_EXN 1         /* "sys","Sys_error",1 */
#define FAILURE_EXN 2           /* "exc","Failure",3 */
#define INVALID_EXN 3           /* "exc","Invalid_argument",2 */
#define END_OF_FILE_EXN 4       /* "io","End_of_file",1 */
#define ZERO_DIVIDE_EXN 5       /* "int","Division_by_zero",1 */
#define BREAK_EXN 6             /* "sys","Break",2 */
#define NOT_FOUND_EXN 7         /* "exc","Not_found",4 */
#define PARSE_FAILURE_EXN 8     /* "stream","Parse_failure",1 */

#if defined(__GNUC__) && defined(__palmos__)
/*
 * FRX: prc-tools libc defines a setjmp/longjmp, but it's bogus
 *  1- the include uses ints instead of longs
 *  2- it isn't Posix (possible workaround)
 *      typedef jmpbuf jmp_buf[1]; 
 *  3- even after fixing that, it doesn't work as expected
 * Thus we postulate that the following (using traps...) works.
 * TODO: fix compile-time warnings
 */
typedef ErrJumpBuf jmp_buf[1];
#define setjmp(buf) ErrSetJump(buf)
#define longjmp(buf,res) ErrLongJump(buf,res)
#endif

struct longjmp_buffer {
  jmp_buf buf;
};


extern struct longjmp_buffer * external_raise;
extern value exn_bucket;

void mlraise P((value)) __attribute__ ((noreturn));
void raise_with_arg P((tag_t tag, value arg)) __attribute__ ((noreturn));
void raise_with_string P((tag_t tag, char * msg)) __attribute__ ((noreturn));
void failwith P((char *)) __attribute__ ((noreturn));
void invalid_argument P((char *)) __attribute__ ((noreturn));
void raise_out_of_memory P((void)) __attribute__ ((noreturn));

#endif /* _fail_ */
