#include "mlvalues.h"
#include "prims.h"
#include "dispatch.h"
#include "intext.h"
#include "sys.h"

header_t *first_atoms = NULL;

extern c_primitive cprims2[];
extern int cprims2n;

extern void runtime_init(int verb);
extern struct channel *open_descr(VoidHand h);
extern void free_atoms();


code_t alloc_resources(header_t *fatoms)
{
  /* bytecode, global datas */
  VoidHand bh, gh;
  code_t start_code;

  // FrmCustomAlert(0, "Get RSRC", NULL, NULL);
  bh = DmGetResource('CLby',0);
  gh = DmGetResource('CLgl',0);
  if ((bh == NULL) || (gh == NULL)) return NULL;
  start_code = MemHandleLock(bh); /* make sure the code doesn't move */

  /* this allocates the heap and gives pointers to the primitive table and
     primitive info to the runtime library
     */
  // FrmCustomAlert(0, "Start RT", NULL, NULL);
  first_atoms = fatoms;
  { /* memory parameters : to be completed. */
    VoidHand dbh;
    dbh = DmGetResource('CLmm',0);
    if (dbh == NULL)
      runtime_init(0);      /* init gc, stacks, prims for CLRT  */
    else {
      DmReleaseResource(dbh);
      runtime_init(1);
    }
  }
  /* this inits the primitive library (get atoms) */
  declare_prims(1, cprims2, cprims2n, reg_a4); /* declare our prims */

  /* At this point, the runtime is alive */

  // FrmCustomAlert(0, "Load GL", NULL, NULL);
  { /* load the globals  */
    value globs;
    struct channel *chan = open_descr(gh);
    globs = intern_val(chan);
    close_in(chan); /* this releases the resource */
    // FrmCustomAlert(0, "Sys Init", NULL, NULL);
    sys_init(globs);			/* some builtins constants */
  }
  return start_code;
}

/* no more Caml here */
void free_resources(code_t start_code)
{ 
  if (start_code)  { /* Release the bytecode resource */
    VoidHand bh = MemPtrRecoverHandle(start_code);
    if (bh == NULL) {
      FrmCustomAlert(2, "Can't release bytecode resource",NULL,NULL);
    } else {
      MemHandleUnlock(bh);
      DmReleaseResource(bh);
    }
  }
  /* clpalmio_exit();  NOW IN IO close database */
  free_atoms();
#ifdef NEED_FREE_ALL
  xfree_all();
#endif
}


