#include "mlvalues.h"
#include "fail.h"

extern value interprete(code_t prog);
extern void set_external_raise(struct longjmp_buffer *b);
extern void ui_set_exit(struct longjmp_buffer *b);
extern void init_alloc(UInt owner);
extern char *uncaught(void);
extern header_t *get_atoms();
extern void EventLoop();
extern void StopApplication(int fatal);

extern code_t alloc_resources(header_t *fatoms);
extern void free_resources(code_t start_code);


code_t start_code;
header_t *first_atoms;

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
  if (cmd == sysAppLaunchCmdNormalLaunch) {
    struct longjmp_buffer raise_buf;
    code_t start_code = NULL;

    if (setjmp(&raise_buf.buf[0]) == 0) {
      /* Where to go if we die */
      set_external_raise(&raise_buf);
      ui_set_exit(&raise_buf);

      /* If we let the lib allocate memory, it won't be released automatically
       * when we exit. Compute our owner bit, and pass it to the library
       * so that it can pretend to be us.
       */
      {
	VoidHand tmph = MemHandleNew(4);
	UInt owner = MemHandleOwner(tmph);
	MemHandleFree(tmph);
	init_alloc(owner);
      }
      /* StartApplication  */
      first_atoms = get_atoms();
      ErrFatalDisplayIf(first_atoms == NULL, "No atoms");
      if ((start_code = alloc_resources(first_atoms)) == 0)
	return 1;

      /* run the bytecode : it returns after installing handlers in globals */
      // FrmCustomAlert(0, "Start PGM", NULL, NULL);
      interprete(start_code);

      EventLoop();
      StopApplication(0);
    } else {
      FrmCustomAlert(2, uncaught(),NULL,NULL);
      // printf("exiting\n");
      StopApplication(1);
    };
    free_resources(start_code);
    return 0;
  } /* end sysAppLaunchCmdNormalLaunch */
  else return 0;
}
