#include "config.h"
#include "alloc.h"
#include "fail.h"
#include "globals.h"
#include "memory.h"

#ifdef HAS_UI
#include"ui.h"
#endif

/* Small subset of sys_ functions */

/* The usual sys_error expects either SYS_ERROR_NO_ARG
 * or a string value, and uses errno to get a message.
 * INCOMPATIBLE CHANGE: we expect an Err argument
 */
void sys_error(Err err)
{
  char message[128];
  SysErrString(err, message, 127);
  raise_with_arg(SYS_ERROR_EXN, copy_string(message));
}

value sys_exit(retcode)          /* ML */
     value retcode;
{
#ifdef NEED_FREE_ALL
  xfree_all();
#endif
#ifdef HAS_UI
  ui_exit(Int_val(retcode));
#else
  exit(Int_val(retcode));
#endif
  return Val_unit;
}

