#open "palm";;
#open "events";;

(* Resources *)
let mainForm = 1000;;
let entryfield = 100;;
let compute = 102;;
let about = 1;;


let rec fib n =
  if n <= 2 then n
  else fib(n-1) + fib(n-2)
;;

let main_handler form = 
  let entry = fld__get form entryfield in
  (function  
    | CtlSelectEvent (id, pctrl, _)
      	when id = compute -> begin
	  try
	    let s = fld__get_text entry in
	    let n = int_of_string s in
	    let r = fib n in
	    let rs = string_of_int r in
	    win__draw_chars rs (string_length rs) 60 40;
	    true
	  with
	    Not_found -> (* nothing in field *)
	      true
	  | Failure _ ->
	      true
      	end
    | MenuEvent id when id = about ->
      	abt_show_about "Caml";
	true
    | _ -> false)
;;

let main () =
  events__set_apphandler (function 
      FrmLoadEvent id -> 
	let form = frm__init_form id in
	if id = mainForm then begin
	  set_formhandler id (main_handler form)
	end;
	frm__set_active_form form;
	true
    | FrmOpenEvent id ->
	frm__draw_form(frm__get_active_form());
	true
    | AppStopEvent ->
	print_debug "AppStop";
	false;
    | e -> (* do with other handlers *)
	print_event ser_debug e;
	false);
  frm__goto_form(mainForm)
;;

let _ = main ()
;;
