#open "palm";;
#open "events";;

(* Resources *)
let mainForm = 1000;;
let theLst = 1001;;

let debug_int n =
  let s = string_of_int n in
  let l = string_length s in
  win__draw_chars s l 100 100
;;

let main_handler form = 
  (function  
    | LstSelectEvent (id, lst, n) when id = theLst -> debug_int n; true
    | LstEnterEvent (id, lst, n) when id = theLst -> debug_int n; true
    | PenDownEvent _ -> 
  	let lst = lst__get form theLst in
  	let n = lst__get_number_of_items lst in
  	let contents = ref [] in
  	debug_int n;
  	for i = 0 to n - 1 do
	  contents := lst__get_selection_text lst i :: !contents;
  	done;
  	lst__set_lst_choices lst !contents;
	lst__erase_list lst;
	lst__draw_list lst;
	false
    | _ -> false)
;;

let main () =
  events__set_apphandler (function 
      FrmLoadEvent id -> 
	let form = frm__init_form id in
	if id = mainForm then begin
	  set_formhandler id (main_handler form)
	end;
	frm__set_active_form form;
	true
    | FrmOpenEvent id ->
	frm__draw_form(frm__get_active_form());
	true
    | AppStopEvent ->
	print_debug "AppStop";
	false;
    | e -> (* do with other handlers *)
	print_event ser_debug e;
	false);
  frm__goto_form(mainForm)
;;

let _ = main ()
;;
