; Java native routines needed for Jump2

;; native-method *.registerNatives()V
	rts

;; native-method java/lang/Class.getName()Ljava/lang/String;
        move.l  4(a7),a0
        move.l  ClassInfo.Name(a0),a0
        lea     0(pc),a1
        add.l   a1,a0
        bra     CharPtr_to_String

;; native-method java/lang/Object.toString()Ljava/lang/String;
	lea.l	object_to_string__0(pc),a0
	bra	CharPtr_to_String
object_to_string__0:
	dc.b	'an object',0
	align	2

;; native-method java/lang/Throwable.toString()Ljava/lang/String;
	lea.l	throwable_to_string__0(pc),a0
	bra	CharPtr_to_String
throwable_to_string__0:
	dc.b	'a throwable',0
	align	2

;; native-method java/lang/Class.isInterface()Z
        clr.l   d0
        rts

;; native-method java/lang/Class.isPrimitive()Z
        clr.l   d0
        rts

;; native-method java/lang/Class.getPrimitiveClass(Ljava/lang/String;)Ljava/lang/Class;
	clr.l   d0
	move.l	d0,a0
        rts

;; native-method java/lang/Object.getClass()Ljava/lang/Class;
	move.l  4(a7),a0
        bsr     getclassinfo_a0
        add.l   #2,a0
        rts

;; native-method java/lang/Object.hashCode()I
        move.l  4(a7),d0
        rts

;; native-method java/lang/Float.floatToIntBits(F)I
	move.l	4(a7),d0
	rts

;; native-method java/lang/Double.doubleToLongBits(D)J
	move.l	4(a7),d0
	move.l	8(a7),d1
	rts

;; native-method java/lang/Double.longBitsToDouble(J)D
	move.l	4(a7),d0
	move.l	8(a7),d1
	rts

;; native-method java/lang/Runtime.gc()V
	bra	garbage

;; native-method java/lang/System.arraycopy(Ljava/lang/Object;ILjava/lang/Object;II)V
        move.l  4(a7),d2
        move.l  8(a7),d1
        move.l  12(a7),a1
        move.l  16(a7),d0
        move.l  20(a7),a0
	move.l	d3,-(a7)
        tst.l   d2
        beq     arraycopy_out
        cmp.w   Array.length(a0),d0
        bcc     arraycopy_out
        move.l  d0,d3
        add.l   d2,d3
        cmp.w   Array.length(a0),d3
        bhi     arraycopy_out
        cmp.w   Array.length(a1),d1
        bcc     arraycopy_out
        move.l  d1,d3
        add.l   d2,d3
        cmp.w   Array.length(a1),d3
        bhi     arraycopy_out
        mulu    Array.elsize(a0),d2
        mulu    Array.elsize(a0),d0
        mulu    Array.elsize(a0),d1
        move.l  Array.data(a0),a0
        add.l   d0,a0
        move.l  Array.data(a1),a1
        add.l   d1,a1
        systrap MemMove(a1.l,a0.l,d2.l)
arraycopy_out:
	move.l (a7)+,d3
        rts

;; native-method java/lang/Throwable.fillInStackTrace()Ljava/lang/Throwable;
        rts

;; native-method java/lang/Math.floor(D)D
	move.l	8(a7),d1	; lower part
	move.l	4(a7),d0	; higher part
	and.l	#$fffff,d0	; mask to keep mantissa 
	move.w	4(a7),d2	; high word with sign and exp
	bpl.s	math_floor_a
	neg.l	d1
	negx.l	d0
math_floor_a:
	lsr.w	#4,d2
	and.w	#$07ff,d2
	beq.s	math_floor_0	; exp=0: return zero
	sub.w	#1075,d2	; exponent offset
	bcc.s	math_floor_same	; unchanged if very big number
	neg.w	d2
	cmp.w	#53,d2
	bcc.w	math_floor_v
	cmp.w	#32,d2
	bcc.s	math_floor_s
	;; big number: bit mask on lower part
	and.w	#31,d2
	moveq.l	#-1,d3
	lsl.l	d2,d3		; d3 = bit mask, high 1's
	and.l	d3,d1
	bra.s	math_floor_p
math_floor_s:
	;; smaller number: bit mask on higher part
	and.w	#31,d2
	moveq.l	#-1,d3
	lsl.l	d2,d3		; d3 = bit mask, high 1's
	and.l	d3,d0
	clr.l	d1
math_floor_p:			; post-processing -> signed, normalized
	tst.l	d0
	bpl.s	math_floor_q
	neg.l	d1
	negx.l	d0
math_floor_q:
	move.l	4(a7),d2
	and.l	#$fff00000,d2
	btst.l	#20,d0
	beq.s	math_floor_r
	lsr.l	#1,d0
	roxr.l	#1,d1
	add.l	#100000,d2
math_floor_r:
	or.l	d2,d0
	rts
	;; very small number: 0 or -1 depending on sign
math_floor_v:
	tst.l	d0
	bmi.s	math_floor_1
math_floor_0:
	clr.l	d0
	clr.l	d1
	rts
math_floor_1:
	move.l	#$bff00000,d0
	clr.l	d1
	rts
math_floor_same:
	move.l	4(a7),d0
	rts
